<!DOCTYPE html>
<html>
<head>
  <meta charset="UTF-8">
  <title>Form work1</title>
  <script>
    /*
      Задание:
        Создать список дел, в который можно:
        - Добавить новый элемент
        - Удалить элемент
        - Задать что пункт выполнен

      Шаблон элемента:
        <li class="listItem">
            <input type="checkbox" class="DoneCheckbox" />
            <span class="TodoText">{add text}</span>
            <button>Remove</button>
        </li>

    */
    document.addEventListener('DOMContentLoaded', function () {
      const newToDo = document.getElementById('newToDo');
      const AddToDo = document.getElementById('AddToDo');
      const TodoText = document.getElementById('toDoList');

      function createElem (elem, className, text, typeName, parent = document.body) {
        let element = document.createElement(elem);
        if (className) {element.classList.add(className);}
        if (text) {element.innerHTML = text;}        
        if (typeName) {element.type = typeName;}
        parent.appendChild(element);
        return element
      }

      function createItem (text) {
        let li = createElem('li', 'listItem', null, null, TodoText);
        let input = createElem('input', 'DoneCheckbox', null, 'checkbox', li);
        let span = createElem('span', 'TodoText', text, null, li);
        let btn = createElem('button', 'remove', 'Remove', null, li);

        btn.addEventListener('click', function(e) {
          let target = e.target;
          let parent = target.parentElement; 
          parent.remove();
        });
        
        input.addEventListener('click', function(e) {
          let target = e.target;
          let nextSibling = target.nextSibling;
          nextSibling.classList.toggle('done');
        });
      }

      AddToDo.addEventListener('click', function() {
        let task = newToDo.value;
        if (task) {
          createItem(task);
        }
        newToDo.value = '';
      });
    });
  </script>
</head>
<body>
    <header>
      <input id="newToDo" class="textInput"/>
      <input id="AddToDo" class="addButton" type="button" value="Add"/>
    </header>
    <ul id="toDoList"></ul>

  <style>
    .done{
      text-decoration: line-through;
    }
    .textInput{
      box-sizing: border-box;
      padding: 10px 20px;
    }
    .addButton{
      box-sizing: border-box;
      padding: 10px 20px;
      background: #ffcc00;
    }

    .DoneCheckbox,
    .TodoText{
      margin-right: 5px;
    }

    button{
      background: red;
      color: #fff;
      padding: 5px 10px;
    }
  </style>
</body>
</html>
